uniform float timer;

vec3 hsv2rgb(vec3 c) {
  vec4 K = vec4(1.0, 2.0 / 3.0, 1.0 / 3.0, 3.0);
  vec3 p = abs(fract(c.xxx + K.xyz) * 6.0 - K.www);
  return c.z * mix(K.xxx, clamp(p - K.xxx, 0.0, 1.0), c.y);
}

#extension GL_ARB_texture_query_lod : enable

vec4 Process(vec4 color)
{
	vec2 texCoord = gl_TexCoord[0].st;
  
	vec2 texSize = textureSize(tex, 0);
	
	vec2 texCoordRounded = (floor(texCoord * texSize) + vec2(0.499, 0.499)) / texSize;
	vec4 texelTest = textureLod(tex, texCoordRounded, 0);
	
	if (uObjectColor2.a == 0.0) texelTest *= uObjectColor;
	else texelTest *= mix(uObjectColor, uObjectColor2, glowdist.z);

	texelTest = desaturate(texelTest);
	
  	//vec4 texel = getTexel(texCoord);
  
	if (texelTest.a < 1 && texelTest.a > 0.995)
	{
		vec3 hsv = vec3(0, 1, 1);
		hsv.x = timer/8 + pixelpos.y/2048;
	  
		vec3 rgb = hsv2rgb(hsv);
		//texel.rgb = texel.rgb * rgb;
		texelTest.rgb = texelTest.rgb * rgb;
	}
  
 	//texel.rgba = texel.rgba * color;
	texelTest.rgba = texelTest.rgba * color;

	//return texel;
	return texelTest;
}